
#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma", version = "3.8")

library("limma")

#setwd("C:\\Users\\lexb4\\Desktop\\TCGAimmune\\05.normalize")          #设置工作目录
# rt=read.table("estimate_input_uniq.symbol.txt",sep="\t",header=T,check.names=F)           #读取文件
# rt[1:4,1:4]
# rt=as.matrix(rt)
# rownames(rt)=rt[,1]
# exp=rt[,2:ncol(rt)]
# dimnames=list(rownames(exp),colnames(exp))
# data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
# data=avereps(data)
# data=data[rowMeans(data)>0,]
# data[1:4,1:4]
# data <- data.frame(data,check.names = F)
load("C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\01-TCGA_BRCA--FPKM\\03_TCGA_BRCA_uniq.symbol_1204.Rdata")
# data <- out[,-1]
data2[1:4,1:4]


load("C:\\Users\\Administrator\\Desktop\\243-11\\02-一致性聚类-生存-UMAP-PCA\\subtype_1091.Rdata")
risk <- a[order(a$Subtype),]

identical(colnames(data),risk$id)
data <- data2[,risk$id]
table(risk$Subtype)

# normalCount=132               #正常样品数目:Low
# tumorCount=184            #肿瘤样品数目

C1 =473
C2=296
C3=322


#group=c(rep("Low_risk",normalCount),rep("High_risk",tumorCount))
group=c(rep("C1",C1),rep("C2",C2),rep("C3",C3))
#group=rep(c("C1","C2","C3"),times=c(C1,C2,C3))
design <- model.matrix(~factor(group))
colnames(design)=levels(factor(group))
rownames(design)=colnames(data)
v <-voom(data, design = design, plot = F, save.plot = F)
out=v$E
out=rbind(ID=colnames(out),out)
write.table(out,file="uniq.symbol.txt",sep="\t",quote=F,col.names=F)        #输出文件


#--------------CIBERSORT ---------------------------
#install.packages('e1071')
#install.packages('parallel')

#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("preprocessCore", version = "3.8")

#setwd("C:\\Users\\lexb4\\Desktop\\TCGAimmune\\06.CIBERSORT")
source("CIBERSORT.R")
results=CIBERSORT("ref.txt", "uniq.symbol.txt", perm=100, QN=TRUE)

#---------------提取p<0.05的样本--------箱线图---------------
load("")


pFilter=0.05   
immune=read.table("CIBERSORT-Results.txt",sep="\t",header=T,row.names=1,check.names=F)
immune=immune[immune[,"P-value"]<pFilter,]
immune[,c(1:ncol(immune))] <- apply(immune[,c(1:ncol(immune))],2,function(x){as.numeric(x)})

immune2 <- immune[,colMeans(immune)>0]
immune3=immune[,1:(ncol(immune2)-3)]
immune4 <- cbind(id=rownames(immune3),immune3)

#---分组文件
load("C:\\Users\\Administrator\\Desktop\\243-11\\02-一致性聚类-生存-UMAP-PCA\\subtype_1091.Rdata")

mer <- merge(a,immune4,by="id",all=F)
rownames(mer) <- mer$id
merge <- mer[,-1]
save(merge,file="CIBERSORT_immuneCell_subtype.Rdata")

load("CIBERSORT_immuneCell_subtype.Rdata")
table(merge$Subtype)
#---------------箱线图----------
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)

load("CIBERSORT_immuneCell_subtype.Rdata")
hlaexp2 <- merge
boxdata <- gather(hlaexp2,HLA,exp,2:ncol(hlaexp2))
#boxdata[,'exp'] <- sapply(boxdata[,'exp'],function(x){log2(x+1)})

#group分组列变成factor,boxplot按照L,H排列
table(hlaexp2$Subtype)
boxdata$Subtype <- factor(boxdata$Subtype,levels = c('Cluster1','Cluster2',"Cluster3"))

#display.brewer.all()  #显示所有可用颜色
#mycol <- brewer.pal(2,'Dark2')
mycol <- brewer.pal(2,'Set1')[1]

#--------------梅花这个
pdf('CIBERSORT_box.pdf',width =8,height =5)
ggboxplot(boxdata,x='HLA',y='exp',color ='Subtype',
          ylab = 'Relative Expression',
          xlab ='',palette = "Set1",  #nejm #jco #jama#npg#d3#aaas,"aaas"
          add ='jitter',add.params = list(size=0.6,shape=16),   #add ='jitter'
          width=0.5)+
  rotate_x_text(45)+
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=8),
        axis.title = element_text(size=10),
        legend.text = element_text(size=8),
        legend.title = element_text(size=10))+
  stat_compare_means(size = 3,aes(group=Subtype),
                     label = 'p.signif',hide.ns = F)  ##检验方法可以改
#,method = 'wilcox.test'
dev.off()


#-------------多组小提琴箱线图-------------------
pdf('CIBERSORT_box_ggplot2.pdf',width =9,height =6)
ggplot(boxdata,aes(x=HLA,y=exp,fill=Subtype))+  ##fill=vs：按vs分组对ggplot全局进行颜色设置
  #geom_violin()+
  geom_boxplot(width=0.5)+
 # scale_fill_manual(values= mycol)+
  scale_fill_brewer(palette="Set1")+
  labs(x = "", y = "Relative Expression",title="", colour = "black") +
  # coord_flip()+  #???????????Ե?
  #facet_grid(.~HLA) +   #????????????
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=10),    ##坐标轴标签的大小
        axis.title = element_text(size=10),   ###纵坐标字的大小
        legend.text = element_text(size=8),
        legend.title = element_text(size=8))+
  stat_compare_means(size =3,aes(group=Subtype),
                     label = 'p.signif',hide.ns = F,label.x = 1.5,)+
  #theme_bw()+
  rotate_x_text(45)
dev.off()







##---------------filter -plot----------------------------------------
outpdf="barplot.pdf"  
pFilter=0.05   
immune=read.table("CIBERSORT-Results.txt",sep="\t",header=T,row.names=1,check.names=F)
immune=immune[immune[,"P-value"]<pFilter,]
immune=as.matrix(immune[,1:(ncol(immune)-3)])
data=t(immune)
library(RColorBrewer)
mypalette <- colorRampPalette(brewer.pal(8,"Set1"))
col=mypalette(22)
#col=rainbow(nrow(data),s=0.7,v=0.7)
#col <- c("#B2182B","#E69F00","#56B4E9","#009E73","#F0E442","#0072B2","#D55E00","#CC79A7","#CC6666","#9999CC","#66CC99","#999999","#ADD1E5",
 #        "#F0027F","#6A3D9A","#00FFFF","#808000","#0000FF","#CC33FF","#00FF33","#FFD9EC","#181717")

#ann_colors =list(Type=c(High_risk="#D95F02",Low_risk="#1B9E77"))
ann <- brewer.pal(5,'Dark2')
ann_colors =list(Subtype=c(C1=ann[1],C2=ann[2],C3=ann[3]))

#生成图形
pdf(outpdf,height=9,width=15)
par(las=1,mar=c(9,5,6,12),mgp=c(3,0.1,0),cex.axis=1.5)
a1 = barplot(data,col=col,yaxt="n",ylab="Relative Percent",xaxt="n",cex.lab=1.8)
a2=axis(2,tick=F,labels=F)
axis(2,a2,paste0(a2*100,"%"))
axis(1,a1,labels=F,tick = F)
par(srt=60,xpd=T);
#text(a1,-0.02,colnames(data),adj=1.1,cex=0.6);
par(srt=0)
risk <- read.table("risk.txt",header = T,sep = "\t",check.names = F)
Normal <- risk$id[risk$risk =="Low_risk"]
type <- ifelse(colnames(data) %in% Normal ,"Low_risk","High_risk")
table(type)  ##统计高低风险组样本数目
#High_risk  Low_risk 
#180       132
boxcolor <- ifelse(type=="Low_risk","#1B9E77","#D95F02")
points(a1, rep(par('usr')[4]*1.05,length(a1)), pch = 15, col = boxcolor,lwd=5, cex=1.6)
ytick2 = cumsum(data[,ncol(data)])
ytick1 = c(0,ytick2[-length(ytick2)])

legend(par('usr')[2]*0.98,par('usr')[4]*1,legend=rownames(data),col=col,pch=15,bty="n",cex=1,
       #c("High_risk","Low_risk"), 
       #lwd=2,
      # col=c("#E31A1C","#1F78B4")
       )
dev.off()


#--------------  vioplot ----------------------------------------------------
# install.packages("vioplot")
library(vioplot)
library(limma)
pFilter=0.05               
immune=read.table("CIBERSORT-Results.txt",sep="\t",header=T,row.names=1,check.names=F)
immune=immune[immune[,"P-value"]<pFilter,]
immune=as.matrix(immune[,1:(ncol(immune)-3)])
# rownames(immune)=gsub("(.*?)\\-(.*?)\\-(.*?)\\-(.*?)\\-.*","\\1\\-\\2\\-\\3",rownames(immune))
immune=avereps(immune)

# tmb=read.table("TMB.txt",sep="\t",header=T,check.names=F,row.names=1)
# tmb=as.matrix(tmb)
# row.names(tmb)=gsub("(.*?)\\-(.*?)\\-(.*?)\\-(.*?)\\-.*","\\1\\-\\2\\-\\3",row.names(tmb))
# tmb=avereps(tmb)
# lowTmb=tmb[tmb[,"TMB"]<= median(tmb[,"TMB"]),]
# highTmb=tmb[tmb[,"TMB"]>median(tmb[,"TMB"]),]
# lowTmbName=names(lowTmb)
# highTmbName=names(highTmb)
# 根据表达量分为高低表达组
# 高低风险样本
risk <- read.table("risk.txt",sep="\t",header=T)
#risk$id=gsub("(.*?)\\-(.*?)\\-(.*?)\\-(.*?)\\-.*","\\1\\-\\2\\-\\3",risk$id)
Normal= risk$id[risk$risk=="Low_risk"]   #高风险组
Tumor=  risk$id[risk$risk == "High_risk"] #肿瘤组

# tmb=avereps(tmb)
immuneName <- gsub("(.*?)\\-(.*?)\\-(.*?)\\-(.*?)\\-.*","\\1\\-\\2\\-\\3\\",rownames(immune) )
lowTmbImm <-  rownames(immune[immuneName %in% Normal,])
highTmbImm <- rownames(immune[immuneName %in% Tumor,])

# lowTmbImm=intersect(row.names(immune),lowTmbName)
# highTmbImm=intersect(row.names(immune),highTmbName)
rt=rbind(immune[lowTmbImm,],immune[highTmbImm,])
lowTmbNum=length(lowTmbImm)
highTmbNum=length(highTmbImm)
# > highTmbNum
# [1] 124
# > lowTmbNum
# [1] 430

pdf("vioplot.pdf",height=8,width=13)
par(las=1,mar=c(10,6,3,3))
x=c(1:ncol(rt))
y=c(1:ncol(rt))
plot(x,y,
     xlim=c(0,63),ylim=c(min(rt),max(rt)+0.02),
     main="",xlab="", ylab="Fraction",
     pch=21,
     col="white",
     xaxt="n")
for(i in 1:ncol(rt)){
  if(sd(rt[1:lowTmbNum,i])==0){
    rt[1,i]=0.001
  }
  if(sd(rt[(lowTmbNum+1):(lowTmbNum+highTmbNum),i])==0){
    rt[(lowTmbNum+1),i]=0.001
  }
  lowTmbData=rt[1:lowTmbNum,i]
  highTmbData=rt[(lowTmbNum+1):(lowTmbNum+highTmbNum),i]
  
  library(RColorBrewer)
  mycol1 <- brewer.pal(8,"Set1")[1]
  mycol2 <- brewer.pal(8,"Set1")[2]
  
  #vioplot(lowTmbData,at=3*(i-1),lty=1,add = T,col = "#004BFB")   #正常：
  # vioplot(highTmbData,at=3*(i-1)+1,lty=1,add = T,col = "#F91F10")   #疾病
  vioplot(lowTmbData,at=3*(i-1),lty=1,add = T,col = mycol2)   #正常：
  vioplot(highTmbData,at=3*(i-1)+1,lty=1,add = T,col = mycol1)   #疾病
  
  wilcoxTest=wilcox.test(lowTmbData,highTmbData)
  p=wilcoxTest$p.value
  
  mx=max(c(lowTmbData,highTmbData))
  lines(c(x=3*(i-1)+0.2,x=3*(i-1)+0.8),c(mx,mx))
  text(x=3*(i-1)+0.5, y=mx+0.02, labels=ifelse(p<0.001, paste0("p<0.001"), paste0("p=",sprintf("%.03f",p))), cex = 0.8)
}
text(seq(1,64,3),-0.05,xpd = NA,labels=colnames(rt),cex = 1,srt = 45,pos=2)
dev.off()


#-----------------------heatmap------------------
pFilter=0.05               
immune=read.table("CIBERSORT-Results.txt",sep="\t",header=T,row.names=1,check.names=F)
immune=immune[immune[,"P-value"]<pFilter,]
immune=as.matrix(immune[,1:(ncol(immune)-3)])
rt <- as.data.frame(t(immune[,-5]))   #第5列免疫细胞没含量


library(pheatmap)
#由于前边已知low_risk和high_risk各有430和124例样本

Type=c(rep("Low_risk",132),rep("High_risk",180))    #修改对照和处理组样品数目
names(Type)=colnames(rt)
Type <- as.data.frame(Type)
ann_colors =list(Type=c(High_risk="#D95F02",Low_risk="#1B9E77"))

# max(rt);min(rt)
# rt[rt > 0.3 ]=0.3
# rt[rt < -0.3 ]=-0.3

pdf("heatmap.pdf",height=5,width=10)
pheatmap(rt, 
         annotation_colors = ann_colors,
         annotation=Type, 
         color = colorRampPalette(c("navy", "white", "firebrick3"))(50),
         cluster_cols =F,show_colnames=F,
         fontsize = 8,scale="row",
         fontsize_row=7,#clustering_method="average",
         fontsize_col=8)
dev.off()


#########################   相关性图    ###################################################
pFilter=0.05               
immune=read.table("CIBERSORT-Results.txt",sep="\t",header=T,row.names=1,check.names=F)
immune=immune[immune[,"P-value"]<pFilter,]
immune=as.matrix(immune[,1:(ncol(immune)-3)])
rt <- as.data.frame(immune[,-5])

#rt <- rt[,-5]

library(corrplot)
pdf("corHeatmap.pdf",height=13,width=13)              #????ͼƬ???ļ?????
corrplot(corr=cor(rt),
         method = "color",
         order = "hclust",
         tl.col="black",
         addCoef.col = "black",
         number.cex = 0.8,
         col=colorRampPalette(c("navy", "white", "firebrick3"))(50),
)
dev.off()


#-------------------风险评分和模型基因的相关性散点图
library(ggstatsplot)
library(cowplot)

ssgsea <- read.table("risk.txt",sep="\t",header=T,row.names = 1)
colnames(ssgsea)

box3 <- lapply(c("EGFR","TRIB3","ZAP70","CD4"),function(i){
  rttttt <- data.frame(immunity = ssgsea[,i],
                       riskScore = ssgsea[,"riskScore"])
  rownames(rttttt) <- rownames(ssgsea)
  ggscatterstats(data = rttttt,
                 x = riskScore,
                 y = immunity,
                 centrality.para = "mean",
                 margins = "both",
                 xfill = "#CC79A7",
                 yfill = "#009E73",
                 marginal = T,
                 marginal.type = "density")
})
pdf('风险模型基因(EGFR,TRIB3,ZAP70,CD4)与riskScore的相关性.pdf',width = 16,height = 16)
plot_grid(plotlist = box3,nrow = 2,ncol = 2)
dev.off()


#-----------------我原来用的相关性散点图-------------
library(ggplot2)
library(ggpubr)
library(ggpmisc)
colnames(ssgsea)

p1= ggscatter(ssgsea, x = "riskScore", y = "ZAP70",
              add = "reg.line", conf.int = TRUE,    
              add.params = list(fill = "lightgray"))+
  #geom_point(shape = 19,color = "blue")+
  geom_smooth(method = "lm", color = "blue", fill = "lightgray") +  ##E7B800
  stat_cor(method = "pearson",
           label.x = 3, label.y = max(ssgsea$ZAP70)-2)+
  #geom_rug(aes(color =cyl)) +
  theme_bw()

p2=p1+
  labs(title="",   #添加主标题
       #subtitle="xxx",    #添加次标题
       #caption="Data source:xx cancer",  #添加脚注
       x='riskScore',#y='ImmuneScore'            #x和y轴的名字
  )
p2

p3=p2+
  theme(
    plot.title=element_text(color='black',size=15,hjust=0.5),
    plot.subtitle=element_text(color='black',size=16,hjust=0.5),
    plot.caption=element_text(color='black',size=16,face='italic',hjust=1),
    axis.text.x=element_text(color='black',size=14,angle=0),  
    axis.text.y=element_text(color='black',size=14,angle=0),
    axis.title.x=element_text(color='black',size=16,angle=0),
    axis.title.y=element_text(color='black',size=16,angle=90),   
    #lengend.title=element_text(color='black',size=16),
    #lengend.text=element_text(color='black',size=16),
    #panel.grid=element_line(color="grey50",size=2),
    #panel.grid.major=element_line(size=1,linetype =3,color="grey70"),
    legend.position="topright" ,   ##不显示图例,"top"
    panel.border=element_rect(linetype='solid',color="gray",size=1.2,fill=NA)#图四周框起来
  )
#p3 
pdf(file="cor_ZAP70_riskScore.pdf",width=6,height=6)
p3      
dev.off()


#-----------------高低风险组中模型基因的柱状图-----------------
install.packages("tidyr")
install.packages("ggplot2")
install.packages("tidyverse")
library(tidyverse)
library(tidyr)
library(ggplot2)
require(ggpubr)
require(ggsci)
require(cowplot)
library(RColorBrewer)

hlaexp<-read.table("risk.txt",sep="\t",header=T,check.names = F,row.names = 1)
colnames(hlaexp)

hlaexp <- hlaexp[,-c(1,2,7)]
hlaexp <- hlaexp[,c(ncol(hlaexp),1:4)]

hlaexp <- hlaexp[order(hlaexp[,1])]
boxdata <- gather(hlaexp,HLA,exp,2:ncol(hlaexp))
#boxdata$HLA=gsub("\\.","\\-",boxdata$HLA)
#gather之后的boxdata包含三列信息，表达量信息列，分组信息列，基因名称信息列
boxdata[,'exp'] <- sapply(boxdata[,'exp'],function(x){log2(x+1)})

#group分组列变成factor,boxplot按照L,H排列

#boxdata$group <- factor(boxdata$T,levels = c("T1","T2","T3","T4"))
boxdata$group <- factor(boxdata$risk,levels = c('Low_risk','High_risk'))
mycol <- brewer.pal(2,'Dark2')

pdf('modGene_boxplot.pdf',width =8,height =5)
#pdf('gender.pdf',width =9,height = 6)
ggboxplot(boxdata,x='HLA',y='exp',color ='group',
          ylab = 'Relative Expression',
          xlab ='',palette = mycol,  #nejm #jco #jama#npg#d3#aaas#futurama
          add ='jitter',add.params = list(size=0.8,shape=16),   #add ='jitter'
          width=0.4)+   #组多的时候width值调大一点点
  rotate_x_text(45)+
  #coord_flip()+   #颠倒X轴和Y轴
  theme(axis.text=element_text(size=12),    ##坐标轴标签的大小
        axis.title = element_text(size=12),   ###纵坐标字的大小
        legend.text = element_text(size=10),
        legend.title = element_text(size=10))+
  stat_compare_means(size =5,aes(group=group),
                     label = 'p.signif',method = 'wilcox.test',hide.ns = F)  ##检验方法可以改
##2组--wilcox.test，多组kruskal.test
dev.off()








#----------计算模型基因和22种免疫细胞的相关性 -------------------------
library(ggplot2)
library(dplyr)
Sys.setenv(LANGUAGE = "en") #显示英文报错信息
options(stringsAsFactors = FALSE) #禁止chr转成factor

#ssGSEA_output.csv，免疫细胞矩阵，列是免疫细胞，行是样本，由FigureYa71ssGSEA产生。如果对免疫浸润不感兴趣，就把ssGSEA_output.csv换成其他类型的数据，例如临床指标什么的，只要保证样品名跟easy_input_expr.csv一致就好了。
#easy_input_expr.csv，基因表达矩阵，列是样本，行是基因。行也可以是转录本，甚至是临床信息。
#genelist.txt，基因名，将要计算这些基因跟免疫浸润的相关性。要求跟easy_input_expr.csv里的基因名一致。

### 读入ssGSEA的结果；或CIBERSORT结果
tcga_gsva <- read.table("CIBERSORT-Results.txt",sep="\t",row.names = 1,header=T,check.names = F)
risk <- read.table("risk.txt",sep="\t",header=T)
tcga_gsva=tcga_gsva[tcga_gsva[,"P-value"]<0.05,]
tcga_gsva=tcga_gsva[,1:(ncol(tcga_gsva)-3)]
colnames(tcga_gsva)
tcga_gsva <- tcga_gsva[,c(2,3,6,7,9,13,14,16,18,22)]   #差异免疫细胞


Normal= risk$id[risk$risk=="Low_risk"]
Tumor=  risk$id[risk$risk == "High_risk"] 
lowTmbImm <-  rownames(tcga_gsva[rownames(tcga_gsva) %in% Normal,])
highTmbImm <- rownames(tcga_gsva[rownames(tcga_gsva) %in% Tumor,])

#tcga_gsva <- tcga_gsva[highTmbImm,]


### 读入表达量数据
tcga_expr <- data.table::fread("risk.txt", data.table = F, )
#colnames(tcga_expr) <- gsub("\\.","-",colnames(tcga_expr))
## 第一列转为行名
rownames(tcga_expr) <- tcga_expr[,1]
tcga_expr <- tcga_expr[,-1]

## 调整免疫矩阵中的样本顺序
#tcga_gsva <- tcga_gsva[colnames(tcga_expr),]
tcga_expr[1:3,1:4]
tcga_expr <- data.frame(t(tcga_expr),check.names = F)
tcga_expr <- tcga_expr[,rownames(tcga_gsva)]
tcga_expr[1:3,1:4]


### 读入感兴趣的基因
risk <- read.table("risk.txt",sep="\t",header=T)
colnames(risk)
genelist <- colnames(risk)[4:11]   ##模型基因和riskScore
#genelist <- read.table("genes_list.txt")
#genelist <- genelist$V1

###############################  3.批量计算相关性  #####################################################
#输入一个基因，即可返回跟免疫基因的相关性、p值，其中method可以改为“pearson”或“kendall”
gene <- genelist
immuscore <- function(gene){
  y <- as.numeric(tcga_expr[gene,])
  colnames <- colnames(tcga_gsva)
  do.call(rbind,lapply(colnames, function(x){
    dd  <- cor.test(as.numeric(tcga_gsva[,x]), y , method="spearman")
    data.frame(gene=gene,immune_cells=x,cor=dd$estimate,p.value=dd$p.value )
  }))
}

#以FOXP3为例，测试一下函数
#immuscore("FOXP3")

###############################  4.批量计算genelist跟免疫浸润相关性的结果  ####################
data <- do.call(rbind,lapply(genelist,immuscore))
head(data)
table(unique(data$gene));length(unique(data$immune_cells))

#保存到文件
write.csv(data, "modGene-immuneCell_correlation.csv", quote = F, row.names = F)

data1 <- data[abs(data$cor)>0.3 & data$p.value<0.05,]

###############################  5.增加一列，区分p值的大小 ###############################
#使用两个ifelse实现三分类
data$pstar <- ifelse(data$p.value< 0.05 & abs(data$cor)>0.3,
                     ifelse(data$p.value < 0.01 & abs(data$cor)>0.3,"**","*"),
                     "")
data$pstar[1:20]

ggplot(data, aes(immune_cells, gene)) + 
  geom_tile(aes(fill = cor), colour = "white",size=1)+
  scale_fill_gradient2(low = "#2b8cbe",mid = "white",high = "#e41a1c")+
  geom_text(aes(label=pstar),col ="black",size = 5)+
  theme_minimal()+# 不要背景
  theme(axis.title.x=element_blank(),#不要title
        axis.ticks.x=element_blank(),#不要x轴
        axis.title.y=element_blank(),#不要y轴
        axis.text.x = element_text(angle = 45, hjust = 1),# 调整x轴文字
        axis.text.y = element_text(size = 8))+#调整y轴文字
  #调整legen
  labs(fill =paste0(" * p < 0.05","\n\n","** p < 0.01","\n\n","Correlation"))
ggsave("correlation.pdf",width = 8,height = 6)




#---------------------------------------
library(ggplot2)
data1=read.csv("Low_risk_correlation.csv",header=T,stringsAsFactors = FALSE)
#data1 <- data
colnames(data1)
pp = ggplot(data1,aes(immune_cells,gene))
pdf("Low_risk_spearman.pdf", height = 8, width = 12)
pp + geom_point(aes(size=-log10(p.value),color=cor))+   ##r1指相关系数
  scale_colour_gradient2(low="darkblue",mid = "grey",high="red")+scale_size_continuous(range = c(1, 8))+
  xlab("cell_type")+ylab("")+labs(title ="Low_risk")+theme_bw()+
  theme(axis.text.x=element_text(angle=75, hjust=1,size=14),axis.title.x=element_text(size=16))+
  theme(axis.text.y=element_text(size=14),axis.title.y=element_text(size=16))
dev.off()


######-------------矫正p值
library(ggplot2)
data1=read.csv("Low_risk_correlation.csv",header=T,stringsAsFactors = FALSE)
colnames(data1)
pValue=data1[,"p.value"]
fdr=p.adjust(as.numeric(as.vector(pValue)),method="BH")
#fdr=p.adjust(data1[,"p.value"],method="BH")
data2=cbind(data1,fdr=fdr)




