
if (!require("BiocManager"))
  install.packages("BiocManager")
BiocManager::install("maftools")
library(maftools)

#--------------------画图------------------
#setwd("C:\\Users\\lexb4\\Desktop\\tcgaTMB\\03.maftools")
#maf = read.maf(maf = 'C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\03-突变数据\\TCGA.BRCA.varscan.maf')
#maf
ma = read.table('C:\\Users\\Administrator\\Desktop\\243-11\\00-data\\03-突变数据\\TCGA.BRCA.varscan.maf',header = T,sep="\t")
samp <- read.table("C:\\Users\\Administrator\\Desktop\\243-11\\06-CuSig打分模型构建和分析\\01-CuSig模型构建\\06_CuSig_cutpoint.txt",header = T,sep="\t")
L <- samp[samp$group=="Low CuSig score",]$id

Low <- ma[substr(ma$Tumor_Sample_Barcode,1,16) %in% L,]
b <- unique(substr(Low$Tumor_Sample_Barcode,1,16))
a <- intersect(L,b)
write.table(Low,"Low.maf",row.names = F,quote = F,sep="\t")

#--------------------画图------------------
#setwd("C:\\Users\\lexb4\\Desktop\\tcgaTMB\\03.maftools")
maf = read.maf(maf = 'Low.maf')
maf
write.mafSummary(maf = maf, basename = 'maf')

#pdf(file="summary.pdf",width=7,height=6)
#plotmafSummary(maf = maf, rmOutlier = TRUE, addStat = 'median', dashboard = TRUE, titvRaw = FALSE)
#dev.off()

# 自定义变异类型的颜色
#vc_cols = RColorBrewer::brewer.pal(n = 8, name = 'Paired')
#names(vc_cols) = c(
#  'Frame_Shift_Del',
#  'Missense_Mutation',
#  'Nonsense_Mutation',
#  'Multi_Hit',
#  'Frame_Shift_Ins',
#  'In_Frame_Ins',
#  'Splice_Site',
#  'In_Frame_Del'
#)

#print(vc_cols)

pdf(file="Low.maf_waterfall.pdf",width=7,height=6)
oncoplot(maf = maf,
         #colors = vc_cols,
         top = 20, #genes =cu$V1,
         fontSize = 0.6 ,showTumorSampleBarcodes = F )
dev.off()

###可以使用 oncostrip 函数展示特定基因在样本中的突变情况，
###此处查看肝癌中关注较多的'TP53','CTNNB1', 'ARID1A'三个基因，如下：
oncostrip(maf = maf, genes = c('TP53','CTNNB1', 'ARID1A'))

